# -*- coding: utf-8 -*-
"""
Created on Mon Aug 10 09:23:54 2015

@author: Ricco
"""

#importation du module
#l'alias np lui est attribué
import numpy as np

#création manuelle d'un vecteur
a = np.array([1.2,2.5,3.2,1.8])
print(type(a))

#type des données
print(a.dtype)

#nombre de dimension
print(a.ndim)

#nb. lignes et col
#shape est de type tuple!
print(a.shape)

#nombre total d'éléments
print(a.size)

#création et typage implicite
a = np.array([1,2,4])
print(a.dtype)

#création et typage explicite
a = np.array([1,2,4],dtype=float)
print(a.dtype)

#vecteur de booléens
b = np.array([True,False,True,True], dtype=bool)
print(b)

#la donnée peut être un objet python
a = np.array([{"Toto":(45,2000)},{"Tata":(34,1500)}])
print(a.dtype)

#suite arithmétique de raison 1
a = np.arange(0,10)
print(a)

#suite arithmétique de raison step
a = np.arange(0,10,2)
print(a)

#suite nb. de points
a = np.linspace(0,10,5)
print(a)

#vecteur de valeurs identiques
a = np.ones(shape=5)
print(a)

#plus généralement
#peut convenir à des matrices
a = np.full(shape=5,fill_value=3.2)
print(a)

#charger à partir d'un fichier
a = np.loadtxt("vecteur.txt",dtype=float)
print(a)

#conversion à partir d'une liste
lst = [1.2,3.1,4.5]
print(type(lst))

a = np.asarray(lst,dtype=float)
print(type(a))
print(a)

#vecteur de valeurs
a = np.array([1.2,2.5,3.2,1.8])
print(a)
#ajouter une valeur
a = np.append(a,10)
print(a)

#suppression via indice
b = np.delete(a,2)
print(b)

#redimensionnement
a = np.array([1,2,3])
a.resize(5)
print(a)

#concatenation 2 vecteurs
x = np.array([1,2,5,6])
y = np.array([2,1,7,4])
z = np.append(x,y)
print(z)

#####
#EXTRACTIONS
#####

v = np.array([1.2,7.4,4.2,8.5,6.3])

#toutes les valeurs
print(v)
#ou
print(v[:])

#accès indicé - première valeur
print(v[0])

#dernière valeur
print(v[v.size-1])

#plage d'indices contigus
print(v[1:3])

#extrêmes - début to 3
print(v[:3])

#extrêmes - 2 to fin
print(v[2:])

#indice négatif
print(v[-1])

#indices négatifs
print(v[-3:])

#passage par une var.intermédiaire
m = np.array([1,2,3],dtype=int)
print(v[m])

#indices non contigus
m = np.array([0,3,2],dtype=int)
print(v[m])

#résultat est un array
x = v[:3]
print(type(x))

#vecteur de booléens
#si b trop court, tout le reste est considéré False
b = np.array([False,True,False,True,False],dtype=bool)
print(v[b])

#on peut utiliser une condition pour l'extraction
print(v[v < 7])

#la condition est un vecteur de booléen
b = v < 7
print(b)
print(type(b))

#on peut utiliser extract
print(np.extract(v < 7, v))

#recherche valeur max
print(np.max(v))

#recherche indice de valeur max
print(np.argmax(v))

#tri des valeurs
print(np.sort(v))

#récupération des indices triés
print(np.argsort(v))

#valeurs distinctes
a = np.array([1,2,2,1,1,2])
print(np.unique(a))

#fonctions pour les calculs statistiques
#moyenne
print(np.mean(v))

#médiane
print(np.median(v))

#variance
print(np.var(v))

#quantile
print(np.percentile(v,50))

#somme
print(np.sum(v))

#somme cumulée
print(np.cumsum(v))

#calculs entre vecteurs
x = np.array([1.2,1.3,1.0])
y = np.array([2.1,0.8,1.3])

#multiplication
print(x*y)

#addition
print(x+y)

#multiplication par un scalaire
print(2*x)

#comparaison de vecteurs
x = np.array([1,2,5,6])
y = np.array([2,1,7,4])
b = x > y
print(b)

#opérations logiques
a = np.array([True,True,False,True],dtype=bool)
b = np.array([True,False,True,False],dtype=bool)

#ET logique
np.logical_and(a,b)

#OU exclusif logique
np.logical_xor(a,b)

#fonctions spécifiques
#pour le calcul matriciel

#calculs entre vecteurs
x = np.array([1.2,1.3,1.0])
y = np.array([2.1,0.8,1.3])

#produit scalaire
z = np.vdot(x,y)
print(z)
#ou
print(np.sum(x*y))

#norme d'un vecteur
n = np.linalg.norm(x)
print(n)
#ou
import math
print(math.sqrt(np.sum(x**2)))

#opérations ensemblistes
x = np.array([1,2,5,6])
y = np.array([2,1,7,4])

#intersection
print(np.intersect1d(x,y))

#union
print(np.union1d(x,y))

#différence
print(np.setdiff1d(x,y))
